package com.demo.ksqldb.KsqldbDemo;

import com.demo.ksqldb.KsqldbDemo.constants.IKafkaConstants;
import com.demo.ksqldb.KsqldbDemo.subscriber.RowSubscriber;
import io.confluent.ksql.api.client.*;

public class Consumer {

    public void consumeDataFromKsql() throws Exception{
        ClientOptions options = ClientOptions.create()
                .setHost(IKafkaConstants.KSQLDB_SERVER_HOST)
                .setPort(IKafkaConstants.KSQLDB_SERVER_HOST_PORT);
        Client client = Client.create(options);
        //asynchroous usage
        RowSubscriber subscriber = new RowSubscriber();
        client.streamQuery("SELECT * FROM ORDERS EMIT CHANGES")
                .thenAccept(streamedQueryResult -> {
                    Row row = streamedQueryResult.poll();
                    System.out.println(row);
                    streamedQueryResult.subscribe(subscriber);
                }).exceptionally(e -> {
            System.out.println("Request failed: " + e);
            return null;
        });
        //Synchronous Usage
        client.streamQuery("SELECT * FROM ORDERS EMIT CHANGES");
        for (int i = 0; i < 10; i++) {
            // Block until a new row is available
            Row row = client.streamQuery("SELECT * FROM ORDERS EMIT CHANGES").get().poll();
            System.out.println(row);
        }
    }
}
