package com.demo.ksqldb.KsqldbDemo;

import com.demo.ksqldb.KsqldbDemo.constants.IKafkaConstants;
import com.demo.ksqldb.KsqldbDemo.subscriber.RowSubscriber;
import io.confluent.ksql.api.client.Client;
import io.confluent.ksql.api.client.ClientOptions;
import io.confluent.ksql.api.client.InsertsPublisher;
import io.confluent.ksql.api.client.KsqlObject;

public class Producer {

    public void postDataToKsql() {
        ClientOptions options = ClientOptions.create()
                .setHost(IKafkaConstants.KSQLDB_SERVER_HOST)
                .setPort(IKafkaConstants.KSQLDB_SERVER_HOST_PORT);
        Client client = Client.create(options);
        System.out.println("test"+client);
        InsertsPublisher insertsPublisher = new InsertsPublisher();
        RowSubscriber subscriber = new RowSubscriber();
        client.streamInserts("ORDERS", insertsPublisher).toString();
        for (long i = 0; i < 10; i++) {
            KsqlObject ORDER = new KsqlObject()
                    .put("ORDER_ID", 1)
                    .put("PRODUCT_ID", "super_awesome_product")
                    .put("USER_ID", "super_cool_user");
            insertsPublisher.accept(ORDER);
        }
        insertsPublisher.complete();
    }
}
