package com.demo.ksqldb.KsqldbDemo.client;

import io.confluent.ksql.api.client.StreamedQueryResult;

import java.util.concurrent.CompletableFuture;

public interface Client {

    /**
     * Executes a query (push or pull) and returns the results one row at a time.
     *
     * <p>If a non-200 response is received from the server, the {@code CompletableFuture} will be
     * failed.
     *
     * @param sql statement of query to execute
     * @return a future that completes once the server response is received, and contains the query
     *         result if successful
     */
    CompletableFuture<StreamedQueryResult> streamQuery(String sql);



}